public class PodatkovniNosilec{
  //komponente
  private int kapaciteta;
  private String izdelovalec;
  private int cena;
  private int davek;

  //konstruktorji
  //konstruktor brez parametra
  public PodatkovniNosilec(){
    nastaviKapaciteto((int)(650*Math.pow(2, 20)));//v nalogi je bilo treba nastaviti zacetno kapaciteto v kB in ne v B, Math.pow vrne double, zato (int)
    nastaviIme("neznan");
    nastaviCeno(100);
    nastaviObdavcitev(20);
  }

  // konstruktor s parametri
  public PodatkovniNosilec(String ime, int kapliciteta, int cena, int davek){
   this(); //klicemo konst. brez parametrov, v kolikor so vhodni podatki neustrezni
   nastaviKapaciteto(kapaciteta);
   nastaviIme(ime);
   nastaviCeno(cena);
   nastaviObdavcitev(davek);
  }

  //metode za klic in nastavitev
  public void nastaviKapaciteto(int bajti){
    if(bajti>=0) this.kapaciteta=bajti;
  }
  //metoda nastavi Ime, ce je ime enako null, se ne spremeni
  public void nastaviIme(String ime){
    if(ime!=null) this.izdelovalec=ime;
  }
  //metoda nastavi Ceno
  public void nastaviCeno(int cena){
    if(cena>=0)this.cena=cena;
  }

  //metoda nastavi Obdavcitev
  public void nastaviObdavcitev(int procent){
    if(procent>=0 && procent<=100 ) this.davek=procent;
  }

  // metoda vrne osnovno ceno
  public int vrniOsnovnoCeno(){
    return this.cena;
  }

  //metoda vrne davek
  public int vrniDavek(){
    return (this.cena*this.davek)/100;
  }

  //metoda vrne prodajno ceno
  public int vrniProdajnoCeno(){
    return this.cena + vrniDavek();
  }

  //metoda vrne ime proizvajalca
  public String vrniIme(){
    return this.izdelovalec;
  }

  //metoda vrne kapaciteto v enoti
  public double vrniKapaciteto(char enota){
    double a=0;
    if( enota=='b') a=this.kapaciteta;
    else  if( enota=='k') a = this.kapaciteta/1024.0;
    else  if( enota=='m') a = this.kapaciteta/(1024.0*1024);
    else  if( enota=='g') a = this.kapaciteta/(1024.0*1024*1024);
    else a =-0.0;// v primeru, da bi  ze enoto vzel napacno crko
    return a;
  }

  //metoda vrne niz, ki smiselno opisuje razred
  public String toString(){
    return "Izdelovalec "+ this.izdelovalec+" predstavlja medij za shranjevsnje podatkov z kapaciteto "
          +this.kapaciteta+" bajtov, po ceni "+this.cena+" SIT z obdavcitvijo "+this.davek+"%.";
  }
}
</java>


Metodo '''vrniKapaciteto''' bi lahko rešili tudi drugače:
<java>public double vrniKapaciteto(char enota) throws Exception{
    if(enota == 'k') return this.kapaciteta/1024;
    else if(enota == 'M') return this.kapaciteta/Math.pow(2,20); //Math.pow(2,20)=2^20=1024^2
    else if(enota == 'G') return this.kapaciteta/Math.pow(2,30); //Math.pow(2,30)=2^30=1024^3
    else throw new Exception ("Enota " + enota + " ni pravilna.");  //potrebna je sprememba testne metode (try - catch)

  }

  //Testni program

  public class Test {
    public static void main(String[] args) throws Exception{

      //osnovni nosilec
      PodatkovniNosilec m1 = new PodatkovniNosilec();
      System.out.println(m1);

      //nosilec z danimi vrednostmi
      PodatkovniNosilec m2 = new PodatkovniNosilec("model1", 1024, 5000, 20);
      System.out.println(m2);

      //vrnemo kapaciteto 1024b v enoti kilobajt
      try{
        System.out.println(m2.vrniKapaciteto('k'));
      }
      catch (Exception e){
        System.out.println("Izjema v metodi vrniKapaciteto: " + e.getMessage());
      }

      //preverjamo klic this()
      PodatkovniNosilec m3 = new PodatkovniNosilec("model2", 2048, -10000, -12);
      System.out.println(m3);

      //preverjamo: če je kapaciteta negativna, naj se ne spremeni
      m3.nastaviKapaciteto(-2048);
      System.out.println(m3);
    }
}